////Загрузка всех необходимых ассетов для игры
class BattleState extends RootState {
    constructor(){
        super();
        
     }
    init(){
        this.mainInit();
        this.ourCards = [];
        this.ourArtifacts = [];
        this.enemyCards = [];
        this.enemyArtifacts = [];
        this.arrows = [];
        this.mainUI = null;
        this.ourWinsCount = 0;
        this.enemyWinsCount = 0;
        this.isEnd = false;
        this.turnBetMaked = false;
        this.currentTurn = KEEPER.battle.info.turnNumber;
        this.lastTurn = this.currentTurn;
        this.turnBetTime = null;
        this.fonMusic = null;
        this.canDragArtifacts = true;
        this.lastExp = KEEPER.user.experience.current;
        this.needExp = KEEPER.user.experience.max;
        
    
    }
    create() {
        let that = this;
        this.mainCreate();
        //this.game.stage.backgroundColor = '#C0C0C0';
        ///Для fps
        //let music = this.game.add.audio();
        //music.play();
        let startTimer = setInterval(function(){
            if(that.currentTurn !== 0){
                clearInterval(startTimer);
                let ui = that.creteGUI();
                that.fonMusic = ui.addSound('battle_'+that.randomInteger(1, 9),false,0.3);
                that.fonMusic.play();
                //0x919191
                ////Если начало первого хода
                if(that.ifStartFirstTurn()){
                    ////Затухающий черный экран
                    
                    let newUi = ui.addUI(9,true,0,0,ui.width,ui.height,2);
                    let bg = newUi.addBackgroundRect(1,true,false,0x000000,0x8B4513,1,1,1,true);
                    let tween = game.add.tween(bg).to( {alpha: 0}, 1000, Phaser.Easing.Linear.None, true);

                    tween.onComplete.add(function(){
                        newUi.delete();
                        that.onBattleStart();
                        //that.GUI.deleteUI(newUi)
                    }, that);
                    
                    ////
                }
                
                
            }
        },10);
        
        
        
    }
    update(){
        this.mainUpdate();
        ///Если карта открывается
        this.currentTurn = KEEPER.battle.info.turnNumber;
        if(this.lastTurn !== this.currentTurn){
            this.lastTurn = this.currentTurn;
            //this.currentTurn = KEEPER.battle.info.turnNumber;
            this.onTurnChange(); 
            
        }     
        //Если Ставка не сделана и игра не закончена - можем двигать арты
          //Если мы сдались
        ///Если мы сделали ставку, или сдались или конец иры - нельзя двигать артефакты
        if( this.isTurnBet() || this.isEnd || KEEPER.battle.info.isSurrender )
            this.canDragArtifacts = false;
        else
            this.canDragArtifacts = true;
    }
    render(){
        this.mainRender();
    }
    ifStartFirstTurn(){
        if( (KEEPER.battle.info.turnNumber == 1) && (KEEPER.timers.battle.leftPercentTurnTime > 95)){
            return true;
        }else{
            return false;
        }
    }
    creteGUI(){
        let that = this;
        let firstUI = this.GUI.addUI(0,0,this.game.width,this.game.height,null,1,10);
        this.mainUI = firstUI.addUI(1,true,0,0,firstUI.width,firstUI.height,100);
        this.mainUI.addCastomSizeBackground(0,firstUI.width,firstUI.height,'table',1,false);
        
        /*
        ///Добавляем кнопку квестов
        let buttonQuest = this.mainUI.addButton(2,true,this.mainUI.width - 85,30,50,50,'button_quest',function(){
           that.createQuestWindow(false);
        },'onclick','onover',BUTTONVALUE);
        */
        let manualButton = this.mainUI.addButton(2,true,this.mainUI.width - 30,30,50,50,'button_info',function(){
           that.createМanualWindow();
        },'onclick','onover',BUTTONVALUE,1);
        ///Добавляем кнопку квестов
        this.addQuestButton(this.mainUI,this.mainUI.width - 85,30,false);
        //Кнопка сдаться
        
        let helpButton = this.mainUI.addButton(1,true,50,this.mainUI.height*0.5,64,64,'button_flag',function(){
             that.showHelpBet(that.mainUI);
        },'onclick','onover',BUTTONVALUE,1);
        
        /*
        let surrenderButton = this.mainUI.addButton(1,true,this.mainUI.width - 100,this.mainUI.height*0.5,64,64,'button_flag',function(){
             HANDLER.surrendBattle();
        },'onclick','onover',BUTTONVALUE,1);
        
        this.mainUI.addTitle(400,'right','top',ASSETS.textStyles['title'],surrenderButton,function(){
            return ASSETS.getText('text39',LANGUAGE);
        });
        */
        let loader = this.mainUI.addImage(8,false,this.mainUI.width*0.9,this.mainUI.height*0.5,50,50,'load',1,false);
        loader.visible = false;
        loader.animations.add('loading');
        let turnBetMarkerText = this.mainUI.addBitMapText(8,false,this.mainUI.width*0.5,this.mainUI.height*0.5,ASSETS.getText('text40',LANGUAGE),'font_1',35,0.9,false);
        turnBetMarkerText.tint = 0xFFDAB9;
        //let turnBetMarkerText = this.mainUI.addText(8,true,this.mainUI.width*0.5,this.mainUI.height*0.5,ASSETS.getText('text40',LANGUAGE),ASSETS.textStyles['turnBetMarker'],0.5,false);
        //turnBetMarkerText.anchor.setTo(0.5,0.5);
        
        //this.addAllClassRaceIcons(this.mainUI);
        this.startCheckEndBattle(this.mainUI);
        this.addCards(this.mainUI);
        this.addArtifacts(this.mainUI);
        this.addSlashAnimation(this.mainUI)
        this.addTurnTimer(this.mainUI); 
        this.addPlayerInfo(this.mainUI);
        this.mainUI.addUpdate(function(){
            ////Видим всегда кроме, туториал 1, туториал 2, туториал3(ХОД 2 И БОЛЬШЕ) КОНЕЦ
            
            ///Не видим: Туториал 3 - 1 ход туториал 1 2 конц
            /*
            if( ( (KEEPER.battle.info.battleType == 'tutorial') && (KEEPER.battle.info.args[0] == 1) )  ||  ( (KEEPER.battle.info.battleType == 'tutorial') && (KEEPER.battle.info.args[0] == 2) )  ||  (that.currentTurn == 1) || (that.isEnd) ){
                surrenderButton.visible = false;
                surrenderButton.inputEnabled = false;
            }else{
                surrenderButton.visible = true;
                surrenderButton.inputEnabled = true;
            }
            */
            /*
            if((KEEPER.battle.info.battleType == 'tutorial') || (that.isEnd)){
                if((KEEPER.battle.info.battleType == 'tutorial') && (KEEPER.battle.info.args[0] !== 3))
                surrenderButton.visible = false;
                surrenderButton.inputEnabled = false;
            }
            */
            
         
            if(( that.isTurnBet() || KEEPER.battle.info.isSurrender )&&(!that.isEnd)&&((new Date - that.turnBetTime) > 1000)){
                turnBetMarkerText.visible = true;
                loader.visible = true;
                loader.animations.play('loading', 20, true);
         
            }else{
                turnBetMarkerText.visible = false;
                loader.visible = false;
                loader.animations.stop();
          
            }
            if(DEBUGMODE)
                helpButton.visible = true;
            else
                helpButton.visible = false;
        });
        return firstUI;
    }
    onBattleStart(){
        console.log(KEEPER.battle.info.scenario);
        this.showTuntTextIfNeed();
    }
    ///При смене хода
    onTurnChange(){
        if(!this.isEnd)
            this.showTuntTextIfNeed();
        
        //Указываем что ставка не сделана
        this.turnBetMaked = false;
    }
    addAllClassRaceIcons(mainUI){
        let that = this;
        let creatureInfo = ATLAS.getCreatureInfoById(1);
        let raceActions = creatureInfo.actionsType[0];
        let classActions = creatureInfo.actionsType[1];
        let raceAction = ATLAS.getActionTypesById(raceActions)
        let classAction = ATLAS.getActionTypesById(classActions)
        //console.log(raceAction.description)
        let allClassEnemyIcon = mainUI.addImage(8,true,mainUI.width*0.5 + (700/2),mainUI.height*0.5 - 100, 50,50,'all_classes',1,true);
        //allClassEnemyIcon.tint = 0x696969;
        mainUI.addTitle(200,'right','top',ASSETS.textStyles['title'],allClassEnemyIcon,function(){
            
            return classAction.description;
        });
        this.mainUI.width*0.5 - (800/2),this.mainUI.height*0.5 - (600/2)
        let allRaceEnemyIcon = mainUI.addImage(3,true,mainUI.width*0.5 - (700/2),mainUI.height*0.5 - 100, 50, 50,'all_races',1,true);
        //allRaceEnemyIcon.tint = 0x696969;
        mainUI.addTitle(200,'right','top',ASSETS.textStyles['title'],allRaceEnemyIcon,function(){

            return raceAction.description;
        });
        
        let allClassOurIcon = mainUI.addImage(3,true,mainUI.width*0.5 + (700/2),mainUI.height*0.5 + 100, 50, 50,'all_classes',1,true);
        //allClassOurIcon.tint = 0x696969;
        mainUI.addTitle(200,'right','top',ASSETS.textStyles['title'],allClassOurIcon,function(){

            return classAction.description;
        });
        let allRaceOurIcon = mainUI.addImage(3,true,mainUI.width*0.5 - (700/2),mainUI.height*0.5 + 100, 50,50,'all_races',1,true);
        //allRaceOurIcon.tint = 0x696969;
        mainUI.addTitle(200,'right','top',ASSETS.textStyles['title'],allRaceOurIcon,function(){

            return raceAction.description;
        });
        mainUI.addUpdate(function(){
            //console.log('enemyRace:',that.getTypesCount(that.enemyCards,'race'));
            //console.log('enemyClass:',that.getTypesCount(that.enemyCards,'class'));
            //console.log('ourRace:',that.getTypesCount(that.ourCards,'race'));
            //console.log('ourClass:',that.getTypesCount(that.ourCards,'class'));
            if(that.getTypesCount(that.ourCards,'race') == 5){
                allRaceOurIcon.tint = 0x008000;
                //allRaceOurIcon.tint = 0xFFFFFF;
            }
            if(that.getTypesCount(that.ourCards,'class') == 5){
                //allClassOurIcon.tint = 0xFFFFFF;
                allClassOurIcon.tint = 0x008000;
            }
            if(that.getTypesCount(that.enemyCards,'race') == 5){
                //allRaceEnemyIcon.tint = 0xFFFFFF;
                allRaceEnemyIcon.tint = 0xB22222;
            }
            if(that.getTypesCount(that.enemyCards,'class') == 5){
                //allClassEnemyIcon.tint = 0xFFFFFF;//0xFFD700
                allClassEnemyIcon.tint = 0xB22222;
            }
         
        });
    }
    makeBet(){
        this.turnBetMaked = true;
        this.turnBetTime = new Date();
    }
    isTurnBet(){
        return this.turnBetMaked;
    }
    addCards(mainUI){
        let that = this;
        let ui = mainUI.addUI(1,true,mainUI.width*0.5 - (700/2),mainUI.height*0.5 - (400/2),700,400,10);
        //ui.addBackground(0,'ui_1',1,false);
        let position =1;
        let cardCount = 5;
        let cardHeight = 415*0.45; //180
        let cardWidth = 265*0.45;//120
        let distance = 10;
        for(let i =0 ; i < cardCount ; i++){
            
            
            let x = mainUI.width*0.5 - ((cardCount * ( cardWidth + distance ))/2 - cardWidth/2 - distance/2) + (i*(cardWidth+distance))
            let y = mainUI.height*0.5 - cardHeight/2 - 10;
            //let x = forgeUI.width*0.5 - ((plaseCount*(plaseWidth +distance))/2 - plaseWidth/2 - distance/2) + (i*(plaseWidth+distance))
            //let y = forgeUI.height*0.5;
            
            this.enemyCards.push(new Card('enemy',x,y,cardWidth,cardHeight,mainUI,that));
            let arrowImage = mainUI.addImage(2,false,x,mainUI.height*0.5,20,10,'arrows',1,false)
            this.arrows.push({
                position:position,
                image:arrowImage,
            });
            y = mainUI.height*0.5 + cardHeight/2 + 10;
            this.ourCards.push(new Card('our',x,y,cardWidth,cardHeight,mainUI,that));
            
            
            position++;
        }
        
        ui.addUpdate(function(){
            that.ourWinsCount = 0;
            that.enemyWinsCount = 0;
            position =1;
            for(let i in that.enemyCards){
                let creature = KEEPER.getEnemyCardInCurrentBattleByPosition(position);
                that.enemyCards[i].update(creature)
                position++;
            }
            position =1;
            
            for(let i in that.ourCards){
                let creature = KEEPER.getOurCardInCurrentBattleByPosition(position);
                //console.log(creature)
                that.ourCards[i].update(creature)
                position++;
            }
            //Обновление стрелок
            for(let i in that.arrows){
                let ourCard = KEEPER.getOurCardInCurrentBattleByPosition(that.arrows[i].position);
                let enemyCard = KEEPER.getEnemyCardInCurrentBattleByPosition(that.arrows[i].position);
                if(ourCard && enemyCard){
                    if(ourCard.isOpen && enemyCard.isOpen){
                        that.arrows[i].image.visible = true;
                        if(ourCard.points > enemyCard.points){
                           
                            that.arrows[i].image.frame = 0;
                            that.ourWinsCount++;
                        }else if(ourCard.points < enemyCard.points){
                            that.arrows[i].image.frame = 1;
                            that.enemyWinsCount++;
                        }else if(ourCard.points == enemyCard.points){
                            that.arrows[i].image.frame = 2;
                        }
                    }else{
                        that.arrows[i].image.visible = false;
                    }
                    
                }
            }
        });
        
    }
    playEndAnimation(mainUI){
        let that = this;
        let ui = mainUI.addUI(6,true,mainUI.width*0.5 - (800/2),mainUI.height*0.5 - (400/2),800,400,10);
        //ui.addBackground(0,'ui_1',1,false);
        let timeDelta = 1000;
        let counter = 1;
        for(let i = 1 ; i < 6 ; i++){
            let ourCard = that.getOurCardByPosition(i);
            let enemyCard = that.getEnemyCardByPosition(i);

            if(ourCard.points > enemyCard.points){
                
                //let slashCard = ui.addImage(2,false,enemyCard.x + KEEPER.randomInteger(-25, 25),enemyCard.y + KEEPER.randomInteger(-25, 25),256,256,'cross',1,false);
                //slashCard.animations.add('cross');

                setTimeout(function(){
                    //slashCard.animations.play('cross', 10, false);
                    //let sound = ui.addSound('slash',false,0.6);
                    //sound.play();
                    enemyCard.playSlashEffect();
                },counter*timeDelta);


                counter++;
                
            }else if(ourCard.points < enemyCard.points){
                /*
                let slashCard = ui.addImage(2,false,ourCard.x + KEEPER.randomInteger(-25, 25),ourCard.y + KEEPER.randomInteger(-25,25),256,256,'cross',1,false);
                slashCard.animations.add('cross');
                setTimeout(function(){
                    slashCard.animations.play('cross', 10, false);
                    let sound = ui.addSound('slash',false,0.6);
                    sound.play();
                },counter*timeDelta);
                */
                setTimeout(function(){
                    //slashCard.animations.play('cross', 10, false);
                    //let sound = ui.addSound('slash',false,0.6);
                    //sound.play();
                    ourCard.playSlashEffect();
                },counter*timeDelta);
                
                
                counter++;

            }
        }
        ///Выводим окно с инфой
        setTimeout(function(){
            that.createEndWindow(mainUI);
        },(counter*timeDelta)+1000);
    }
    addSlashAnimation(mainUI){
        let that = this;
        let used = false;
        mainUI.addUpdate(function(){
            if((that.isEnd)&&(!used)){
                used = true;
                setTimeout(function(){
                    ///Вырубаем фоновую музыку
                    that.fonMusic.stop();
                    
                    if(!that.isAllCreaturesHasArtifacts()){
                        ///Выводим окно с инфой
                        setTimeout(function(){
                            that.createEndWindow(mainUI);
                        },1000)
                    }else{
                        ///Через полсекунды запускаем анимацию
                        setTimeout(function(){
                            that.playEndAnimation(mainUI);
                        },1000);
                    }
                },500);
            }
        });
    }
    addArtifacts(mainUI){
        let that = this;
        let enemyArtifactUI = mainUI.addUI(1,true,mainUI.width*0.5 - 600 /2,0,600,100,10);   
        //enemyArtifactUI.addBackground(0,'ui_1',1,false); 
        let ourArtifactUI = mainUI.addUI(1,true,mainUI.width*0.5 - 600 /2,mainUI.height - 100,600,100,10);  
        //ourArtifactUI.addBackground(0,'ui_1',1,false); 
        let artifactWidth = 90;
        let artifactHeight = 90;
        let height = artifactHeight;
        let width = artifactWidth;
        //let cardCount = 5;
        //let cardHeight = 415*0.45; //180
        //let cardWidth = 265*0.45;//120
        let distance = -20;
        ///Установить артефакты на начальные позиции
        function setArtifactsOnStartPoint(){
            /*
            for(let i = 0 ; i < 7; i++){
                let height = artifactHeight;
                let width = artifactWidth;

                let num = that.enemyArtifacts.push(new Artifact('enemy',75,75,width,height,mainUI,that));
                that.enemyArtifacts[num - 1].sprite.input.enabled = false;

                let num2 = that.ourArtifacts.push(new Artifact('our',75,mainUI.height - ( 75) - (i*3),width,height,mainUI,that));
                that.ourArtifacts[num2 - 1].sprite.input.enabled = false;
            }
            */
            
            console.log(KEEPER.battle.data.enemyArtifacts)
            for(let i = 0 ; i < KEEPER.battle.data.enemyArtifacts.length; i++){
                
                let num = that.enemyArtifacts.push(new Artifact('enemy',75,75,width,height,mainUI,that));
                that.enemyArtifacts[num - 1].sprite.input.enabled = false;

            }
            for(let i = 0 ; i < KEEPER.battle.data.ourArtifacts.length; i++){
               
                let num2 = that.ourArtifacts.push(new Artifact('our',75,mainUI.height - ( 75) - (i*3),width,height,mainUI,that));
                that.ourArtifacts[num2 - 1].sprite.input.enabled = false;
            }

            setTimeout(function(){
                let i1 = KEEPER.battle.data.enemyArtifacts.length - 1;
                let i2 = 6;
                let timeCounter1 = KEEPER.battle.data.enemyArtifacts.length -1;
                let timeCounter2 = 6;
                /*
                let timer = setInterval(function(){
                    if(i == 0){
                        clearInterval(timer);
                    }
                    let enemyArtifact = that.enemyArtifacts[i];
                    let ourArtifact = that.ourArtifacts[i];
                    
                    let x = enemyArtifactUI.x +enemyArtifactUI.width*0.5 - ((that.enemyArtifacts.length * ( width + distance ))/2 - width/2 - distance/2) + (i*(width+distance))
                    
                    //let x = enemyArtifactUI.x + enemyArtifactUI.width*0.5 - ((width/1.5 +10)*3) + (i*(width/1.5+10));
                    let y = enemyArtifactUI.y + enemyArtifactUI.height*0.5;
                    enemyArtifact.move(x,y,200+(timeCounter*100),function(){
                        enemyArtifact.sprite.input.enabled = true;
                    });
                    
                    x = ourArtifactUI.x + ourArtifactUI.width*0.5 - ((that.ourArtifacts.length * ( width + distance ))/2 - width/2 - distance/2) + (i*(width+distance))
                    
                    //x = ourArtifactUI.x + ourArtifactUI.width*0.5 - ((width/1.5 +10)*3) + (i*(width/1.5+10));
                    y = ourArtifactUI.y + ourArtifactUI.height*0.5;

                    ourArtifact.move(x,y,200+(timeCounter*100),function(){
                        ourArtifact.sprite.input.enabled = true;
                    });


                    i--; 
                    timeCounter--;
                },200);
                */
                
                let timer = setInterval(function(){
                    if(i1 == 0){
                        clearInterval(timer);
                    }
                    let enemyArtifact = that.enemyArtifacts[i1];
               
                    
                    let x = enemyArtifactUI.x +enemyArtifactUI.width*0.5 - ((KEEPER.battle.data.enemyArtifacts.length * ( width + distance ))/2 - width/2 - distance/2) + (i1*(width+distance))
                    
                    //let x = enemyArtifactUI.x + enemyArtifactUI.width*0.5 - ((width/1.5 +10)*3) + (i*(width/1.5+10));
                    let y = enemyArtifactUI.y + enemyArtifactUI.height*0.5;
                    enemyArtifact.move(x,y,200+(timeCounter1*100),function(){
                        enemyArtifact.sprite.input.enabled = true;
                    });

                    i1--; 
                    timeCounter1--;
                },200);
                let timer2 = setInterval(function(){
                    if(i2 == 0){
                        clearInterval(timer2);
                    }
                 
                    let ourArtifact = that.ourArtifacts[i2];
                    let x = ourArtifactUI.x + ourArtifactUI.width*0.5 - ((KEEPER.battle.data.ourArtifacts.length * ( width + distance ))/2 - width/2 - distance/2) + (i2*(width+distance))
                    
                    //x = ourArtifactUI.x + ourArtifactUI.width*0.5 - ((width/1.5 +10)*3) + (i*(width/1.5+10));
                    let y = ourArtifactUI.y + ourArtifactUI.height*0.5;

                    ourArtifact.move(x,y,200+(timeCounter2*100),function(){
                        ourArtifact.sprite.input.enabled = true;
                    });


                    i2--; 
                    timeCounter2--;
                },200);
            },1000);
        }
        ///Установить артефакты на текущие
        function setArtifactsOnCurrentPlase(){
            /*
            for(let i = 0 ; i < 7; i++){
                let height = artifactHeight;
                let width = artifactWidth;

                let x = enemyArtifactUI.x + enemyArtifactUI.width*0.5 - ((width/1.5 +10)*3) + (i*(width/1.5+10));
                let y = enemyArtifactUI.y + enemyArtifactUI.height*0.5;
        
                let num = that.enemyArtifacts.push(new Artifact('enemy',x,y,width,height,mainUI,that));
                

                x = ourArtifactUI.x + ourArtifactUI.width*0.5 + ((width/1.5 +10)*3) - (i*(width/1.5+10));
                y = ourArtifactUI.y + ourArtifactUI.height*0.5;

                let num2 = that.ourArtifacts.push(new Artifact('our',x,y,width,height,mainUI,that));
            }
            */
            console.log(KEEPER.battle.data.enemyArtifacts)
            for(let i = 0 ; i < KEEPER.battle.data.enemyArtifacts.length; i++){
                
                let x = enemyArtifactUI.x +enemyArtifactUI.width*0.5 - ((KEEPER.battle.data.enemyArtifacts.length * ( width + distance ))/2 - width/2 - distance/2) + (i*(width+distance))
                    
                //let x = enemyArtifactUI.x + enemyArtifactUI.width*0.5 - ((width/1.5 +10)*3) + (i*(width/1.5+10));
                let y = enemyArtifactUI.y + enemyArtifactUI.height*0.5;
        
                let num = that.enemyArtifacts.push(new Artifact('enemy',x,y,width,height,mainUI,that));
        
            }
            for(let i = 0 ; i < KEEPER.battle.data.ourArtifacts.length; i++){
                

                let x = ourArtifactUI.x + ourArtifactUI.width*0.5 - ((KEEPER.battle.data.ourArtifacts.length * ( width + distance ))/2 - width/2 - distance/2) + (i*(width+distance))
                    
                //x = ourArtifactUI.x + ourArtifactUI.width*0.5 - ((width/1.5 +10)*3) + (i*(width/1.5+10));
                let y = ourArtifactUI.y + ourArtifactUI.height*0.5;
                let num2 = that.ourArtifacts.push(new Artifact('our',x,y,width,height,mainUI,that));
            }
            
            
        }
        ///Обноврение массива артифактов
        function updateArtifactsArray(side,array){
            
            for(let i in array){
                let artifact;
                if(side == 'enemy')
                    artifact = KEEPER.battle.data.enemyArtifacts[i]
                else if (side == 'our')
                    artifact = KEEPER.battle.data.ourArtifacts[i]  
                array[i].update(artifact);
             
            }
        }
        ///Если это первый ход и прошло только до 5 % времени
        if(this.ifStartFirstTurn()){
            setArtifactsOnStartPoint();
        }else{
     
            setArtifactsOnCurrentPlase();
        }
        updateArtifactsArray('enemy',that.enemyArtifacts);
        updateArtifactsArray('our',that.ourArtifacts);
        
        mainUI.addUpdate(function(){
            updateArtifactsArray('enemy',that.enemyArtifacts);
            updateArtifactsArray('our',that.ourArtifacts);
        });
    }
    addArtifactsOld(mainUI){
        let that = this;
        let enemyArtifactUI = mainUI.addUI(5,true,mainUI.width - 100,150,100,600,10);   
        enemyArtifactUI.addBackground(0,'ui_1',1,false); 
        let ourArtifactUI = mainUI.addUI(5,true,0,mainUI.height - 600 - 150,100,600,10);  
        ourArtifactUI.addBackground(0,'ui_1',1,false); 
        let artifactWidth = 110;
        let artifactHeight = 110;
        ///Установить артефакты на начальные позиции
        function setArtifactsOnStartPoint(){
            for(let i = 0 ; i < 7; i++){
                let height = artifactHeight;
                let width = artifactWidth;

                let num = that.enemyArtifacts.push(new Artifact('enemy',mainUI.width - ( 64),64 + (i*3),width,height,enemyArtifactUI,that));
                that.enemyArtifacts[num - 1].sprite.input.enabled = false;

                let num2 = that.ourArtifacts.push(new Artifact('our',64,mainUI.height - ( 64) - (i*3),width,height,ourArtifactUI,that));
                that.ourArtifacts[num2 - 1].sprite.input.enabled = false;
            }

            setTimeout(function(){
                let i = 6;
                let timer = setInterval(function(){
                    if(i == 0){
                        clearInterval(timer);
                    }
                    let height = artifactHeight;
                    let width = artifactWidth;
                    let enemyArtifact = that.enemyArtifacts[i];
                    let ourArtifact = that.ourArtifacts[i];
                    let x = enemyArtifactUI.x + enemyArtifactUI.width*0.5;
                    let y = enemyArtifactUI.y + enemyArtifactUI.height*0.5 - ((height/1.5 +10)*3) + (i*(height/1.5+10));
                    enemyArtifact.move(x,y,200+(i*100),function(){
                        enemyArtifact.sprite.input.enabled = true;
                    });

                    x = ourArtifactUI.x + ourArtifactUI.width*0.5;
                    y = ourArtifactUI.y + ourArtifactUI.height*0.5 + ((height/1.5 +10)*3) - (i*(height/1.5+10))

                    ourArtifact.move(x,y,200+(i*100),function(){
                        ourArtifact.sprite.input.enabled = true;
                    });


                    i--; 
                },200);
            },1000);
        }
        ///Установить артефакты на текущие
        function setArtifactsOnCurrentPlase(){
            for(let i = 0 ; i < 7; i++){
                let height = artifactHeight;
                let width = artifactWidth;

                let x = enemyArtifactUI.x + enemyArtifactUI.width*0.5;
                let y = enemyArtifactUI.y + enemyArtifactUI.height*0.5 - ((height/1.5 +10)*3) + (i*(height/1.5+10));
        
                let num = that.enemyArtifacts.push(new Artifact('enemy',x,y,width,height,enemyArtifactUI,that));
                

                x = ourArtifactUI.x + ourArtifactUI.width*0.5;
                y = ourArtifactUI.y + ourArtifactUI.height*0.5 + ((height/1.5 +10)*3) - (i*(height/1.5+10))

                let num2 = that.ourArtifacts.push(new Artifact('our',x,y,width,height,ourArtifactUI,that));
            }
        }
        ///Обноврение массива артифактов
        function updateArtifactsArray(side,array){
            
            for(let i in array){
                let artifact;
                if(side == 'enemy')
                    artifact = KEEPER.battle.data.enemyArtifacts[i]
                else if (side == 'our')
                    artifact = KEEPER.battle.data.ourArtifacts[i]  
                array[i].update(artifact);
             
            }
        }
        ///Если это первый ход и прошло только до 5 % времени
        if(this.ifStartFirstTurn()){
            setArtifactsOnStartPoint();
        }else{
     
            setArtifactsOnCurrentPlase();
        }
        updateArtifactsArray('enemy',that.enemyArtifacts);
        updateArtifactsArray('our',that.ourArtifacts);
        
        mainUI.addUpdate(function(){
            updateArtifactsArray('enemy',that.enemyArtifacts);
            updateArtifactsArray('our',that.ourArtifacts);
        });
    }
    createCardWindow(cardTypeId){
        var that = this;
        let ui = this.mainUI.addUI(8,true,this.mainUI.width*0.5 - (800/2),this.mainUI.height*0.5 - (600/2),800,600,10);
        ui.addFullWindowRect(0,0,0,this.game.width,this.game.height,true,0x000000,0.5,function(){
            ui.delete();
            //that.GUI.deleteUI(ui);
        });
        
        //ui.addBackgroundRect(0,true,true,0x919191,0x8B4513,1,0.8,1,false);
        //ui.addBackground(0,'ui_3',1,true);
        let cardInfo = ATLAS.getCreatureInfoById(cardTypeId);
        let raceInfo = ATLAS.getRaceInfoById(cardInfo.raceId);
        let classInfo = ATLAS.getClassInfoById(cardInfo.classId);
        
        let card = ui.addImage(3,true,ui.width*0.25 ,ui.height*0.5, 256, 384,cardInfo.imageKey,1,false);
        card.frame = cardInfo.imageFrame;
        /*
        ui.addDynamycTitle(3,400,card,'right','top',ASSETS.textStyles['title'],function(){
                            
            return raceInfo.name+'\n'+raceInfo.description+'\n'+classInfo.name+'\n'+classInfo.description;
        });
        */
        let raceImage = ui.addImage(3,true,ui.width*0.7 ,ui.height*0.3 , 64, 64,raceInfo.imageKey,1,true);
        raceImage.frame = raceInfo.imageFrame;
        /*
        ui.addDynamycTitle(3,400,raceImage,'right','top',ASSETS.textStyles['title'],function(){
            let actionsString = '';
            for(let i = 0;i < raceInfo.actionsType.length;i++){
                if(i != 0)
                    actionsString += '\n'
                    actionsString += ATLAS.getActionTypesById(raceInfo.actionsType[i]).description;
                }              
            return raceInfo.name;//+'\n'+actionsString;
        });
        */
         let classImage = ui.addImage(3,true,ui.width*0.7 ,ui.height*0.7 , 64, 64,classInfo.imageKey,1,true);
        classImage.frame = classInfo.imageFrame;
        /*
        ui.addDynamycTitle(3,400,classImage,'right','top',ASSETS.textStyles['title'],function(){
            let actionsString = '';
            for(let i = 0;i < classInfo.actionsType.length;i++){
                if(i != 0)
                    actionsString += '\n'
                    actionsString += ATLAS.getActionTypesById(classInfo.actionsType[i]).description;
                }              
            return classInfo.name;//+'\n'+actionsString;                
        });
        */
        console.log(raceInfo.nameText)
       let raceText = ui.addBitMapText(1,false,raceImage.x,raceImage.y + raceImage.height,ASSETS.getText(raceInfo.nameText,LANGUAGE),'font_1',35,1,false);
        //let raceText = ui.addText(1,false,raceImage.x,raceImage.y + raceImage.height,ASSETS.getText(raceInfo.nameText,LANGUAGE),ASSETS.textStyles['cardDescription'],1,false);
        //raceText.anchor.setTo(0.5,0.5);
        raceText.wordWrapWidth = 350;
        //ui.addImage(3,false,card.x + card.width*0.3,card.y - card.height*0.1, 128, 128,classInfo.imageKey,1,false);
        let classText = ui.addBitMapText(1,false,classImage.x,classImage.y + classImage.height,ASSETS.getText(classInfo.nameText,LANGUAGE),'font_1',35,1,false);
        //let classText = ui.addText(1,false,classImage.x,classImage.y + classImage.height,ASSETS.getText(classInfo.nameText,LANGUAGE),ASSETS.textStyles['cardDescription'],1,false);
        //classText.anchor.setTo(0.5,0.5);
        classText.wordWrapWidth = 350;
    
    }
    createEndWindow(mainUI){
        var that = this;
        //ui.addFullWindowRect(0,0,0,this.game.width,this.game.height,true,0x000000,0.5,function(){
        //});
        mainUI.addButtonWithText(1,true,mainUI.width - 55,mainUI.height - 20,96,32,'button_empty',function(){
            that.createBattleResoultWindow(mainUI);
        },'onclick','onover',BUTTONVALUE,ASSETS.getText('text70',LANGUAGE),ASSETS.textStyles['button'],1);
        mainUI.addButtonWithText(1,true,mainUI.width - 55,mainUI.height - 55,96,32,'button_empty',function(){
            that.closeBattle();
        },'onclick','onover',BUTTONVALUE,ASSETS.getText('text69',LANGUAGE),ASSETS.textStyles['button'],1);
        
        ///Финальная музыка////////////////
        let winMusic = mainUI.addSound('win',false,0.7);
        let looseMusic = mainUI.addSound('lose',false,0.7);
        let drawMusic = mainUI.addSound('draw',false,0.7);
        
        ///Если победили
        if(KEEPER.battle.result.win){
            winMusic.play();
        }else{
            ///Если Ничья
            if(KEEPER.battle.result.winner == 'draw'){
                drawMusic.play();
            }
            ///Если Проиграли
            else{
               looseMusic.play();
            } 
        }
        /////////////////////////////////
        
        
        
        this.createBattleResoultWindow(mainUI);
        
        
    }
    createBattleResoultWindow(mainUI){
        var that = this;
        let windowName = 'resoult';
        ///Если это окно уже открыто не  создаем его
        if(that.isWindowOpen(windowName))
            return false;
        //Ставим флаг что окно открыто
        that.openWindow(windowName);
        function onClose(){
            that.closeWindow(windowName);
            firstUi.delete();
        }
        
        let firstUi = that.GUI.addUI(that.game.width/2 - 500,that.game.height/2 - 300,1000,600,null,null,10);
        firstUi.addFullWindowRect(0,0,0,that.game.width,that.game.height,true,0x000000,0.5,function(){
            onClose();
        });
        
        firstUi.addBackground(1,'ui_400_200',1,true);
        let ui = firstUi.addUI(1,true,firstUi.width/2 - 200,firstUi.height/2 - 100,400,200,15);
        ui.addButton(1,true,ui.width -30,30,60,60,'button_close',function(){
            onClose();
        },'onclick','onover',BUTTONVALUE,1);
        //let uiName = ui.addBitMapText(1,true,ui.width*0.5,-30,ASSETS.getText('text125',LANGUAGE),'font_1',30,1,false);
        //uiName.tint = 0xFFDAB9;
        //ui.addBackgroundRect(0,true,true,0x919191,0x8B4513,1,0.8,1,true);
        
        let resultText = '';
        let res = 'draw';
        if(KEEPER.battle.result.win){
            //Если у противника существа с артифактами значит мы победили, иначе значит он сдался
            if(that.isAllEnemyCreaturesHasArtifacts()){
                resultText = ASSETS.getText('text41',LANGUAGE)+'!';
            }else{
                resultText = ASSETS.getText('text76',LANGUAGE);
            }
            res = 'win';
        }else{
            if(KEEPER.battle.result.winner == 'draw'){
                resultText = ASSETS.getText('text42',LANGUAGE);
                res = 'draw';
            }else{
                ///Если все существа с артифактами занчит проиграли если нет - значит 
                if(that.isAllOurCreaturesHasArtifacts()){
                    resultText = ASSETS.getText('text43',LANGUAGE); //////\nПобедитель '+KEEPER.battle.result.winner;
                }else{
                    resultText = ASSETS.getText('text75',LANGUAGE);
                }
                res = 'loose';
            } 
        }
        //let resoultText = ui.addText(1,true,ui.width*0.5,50,resultText,ASSETS.textStyles['cardDescription'],1,false);
        let resoultText = ui.addBitMapText(1,true,ui.width*0.5,50,resultText,'font_1',30,1,false);
        resoultText.tint = 0x9932CC;
        //resoultText.fill = '#D2691E';
        let expUI = ui.addUI(2,true,ui.width*0.3 - (100/2),ui.height*0.5,100,40,10);
        //raitingUI.addBackgroundRoundedRect(0,true,false,0x000000,0x000000,0,0.2,1,15,false)
        //raitingUI.addBackgroundRect(0,true,true,0x919191,0x8B4513,1,0.8,1,true);
        let exp = expUI.addImage(1,true,expUI.width*0.3,expUI.height*0.5,32,32,'battleCount',1,true);
        
        
        exp.frame = 5;
        let calor = 0x90EE90;
        let diffexp = KEEPER.user.experience.current - this.lastExp;
        if(diffexp < 0){
            diffexp = this.needExp - this.lastExp + KEEPER.user.experience.current;
        }
        
        let expText = expUI.addBitMapText(1,true,expUI.width*0.7,expUI.height*0.5,String(KEEPER.battle.result.getExperience),'font_1',18,1,false);
        expText.tint = calor;
        
        let coinsUI = ui.addUI(2,true,ui.width*0.7 - (100/2),ui.height*0.5,100,40,10);
        //raitingUI.addBackgroundRoundedRect(0,true,false,0x000000,0x000000,0,0.2,1,15,false)
        //raitingUI.addBackgroundRect(0,true,true,0x919191,0x8B4513,1,0.8,1,true);
        let coins = coinsUI.addImage(1,true,coinsUI.width*0.3,coinsUI.height*0.5,32,32,'coins',1,true);
        let coinsText = coinsUI.addBitMapText(1,true,coinsUI.width*0.7,coinsUI.height*0.5,String(KEEPER.battle.result.getCoins),'font_1',18,1,false);
        coinsText.tint = 0xFFD700;
        /*
        ui.addTitle(200,'right','bot',ASSETS.textStyles['title'],raiting,function(){
            return ASSETS.getText('text15',LANGUAGE)+'\n1. '+KEEPER.getLoginByRaitingPosition(1)+'\n2. '+KEEPER.getLoginByRaitingPosition(2)+'\n3. '+KEEPER.getLoginByRaitingPosition(3);
        });
        */
        /*
        ///////////////////ЗАКОМЕНЧЕНЫ АРТЫ КОТОРЫЕ ПОЛУЧАЕМ И ТЕРЯЕМ
        let artWidth = 90;
        let artHeight = 90;
        let distance = 10;
        let lostUI = ui.addUI(2,true,ui.width*0.5 - (400/2),ui.height*0.5 - (150/2),400,150,10);
        //lostUI.addBackgroundRect(0,true,true,0x919191,0x8B4513,1,0.8,1,true);
        if(res == 'win'){
            let winText = lostUI.addBitMapText(1,true,lostUI.width*0.5,lostUI.height*0.1,ASSETS.getText('text45',LANGUAGE)+':','font_1',18,1,false);
            winText.tint = 0x008000;
            for(let i = 0; i <  KEEPER.battle.result.winArtifacts.length;i++){
                let x = lostUI.width*0.5 - ((KEEPER.battle.result.winArtifacts.length*(artWidth +distance))/2 - artWidth/2 - distance/2) + (i*(artWidth+distance))
                let artInfo = ATLAS.getArtifactInfoById(KEEPER.battle.result.winArtifacts[i]);
                let art = lostUI.addImage(3,true,x,lostUI.height*0.6 , artWidth, artHeight,artInfo.imageKey,1,true);
                lostUI.addTitleTextWithImages(250,'top','right','center',ASSETS.wordStyles,ASSETS.textStyles['title'],art,function(){
                    return KEEPER.getArtifactTextInfo(artInfo.id);
                });
            }
        }else{
            let loseText = lostUI.addBitMapText(1,true,lostUI.width*0.5,lostUI.height*0.1,ASSETS.getText('text44',LANGUAGE)+':','font_1',18,1,false);
            loseText.tint = 0x8B0000;
            for(let i = 0; i <  KEEPER.battle.result.loseArtifacts.length;i++){
                let x = lostUI.width*0.5 - ((KEEPER.battle.result.loseArtifacts.length*(artWidth +distance))/2 - artWidth/2 - distance/2) + (i*(artWidth+distance))
                let artInfo = ATLAS.getArtifactInfoById(KEEPER.battle.result.loseArtifacts[i]);
                let art = lostUI.addImage(3,true,x,lostUI.height*0.6 , artWidth, artHeight,artInfo.imageKey,1,true);
                lostUI.addTitleTextWithImages(250,'top','right','center',ASSETS.wordStyles,ASSETS.textStyles['title'],art,function(){
                    return KEEPER.getArtifactTextInfo(artInfo.id);
                });
            }
        }
        */
        /*
        //resoultText.anchor.setTo(0.5,0.5);
        let loseText = ui.addBitMapText(1,true,ui.width*0.5,ui.height*0.3,ASSETS.getText('text44',LANGUAGE)+':','font_1',18,1,false);
        //let loseText = ui.addText(1,true,ui.width*0.5,ui.height*0.3,ASSETS.getText('text44',LANGUAGE)+':',ASSETS.textStyles['common'],1,false);
        //loseText.anchor.setTo(0.5,0.5);
        for(let i = 0; i <  KEEPER.battle.result.loseArtifacts.length;i++){
            let artInfo = ATLAS.getArtifactInfoById(KEEPER.battle.result.loseArtifacts[i]);
            ui.addImage(3,true,ui.width*0.5 - 64*(Math.floor(KEEPER.battle.result.loseArtifacts.length/2)) + 64*i ,ui.height*0.4 , 64, 64,artInfo.imageKey,1,true);
        }
        let winText = ui.addBitMapText(1,true,ui.width*0.5,ui.height*0.5,ASSETS.getText('text45',LANGUAGE)+':','font_1',18,1,false);
        //let winText = ui.addText(1,true,ui.width*0.5,ui.height*0.5,ASSETS.getText('text45',LANGUAGE)+':',ASSETS.textStyles['common'],1,false);
        //winText.anchor.setTo(0.5,0.5);
        for(let i = 0; i <  KEEPER.battle.result.winArtifacts.length;i++){
            let artInfo = ATLAS.getArtifactInfoById(KEEPER.battle.result.winArtifacts[i]);
            ui.addImage(3,true,ui.width*0.5 - 64*(Math.floor(KEEPER.battle.result.winArtifacts.length/2)) + 64*i ,ui.height*0.6 , 64, 64,artInfo.imageKey,1,true);
        }
        */
        
        //let timeText = ui.addText(1,true,ui.width*0.5,ui.height*0.75,ASSETS.getText('text46',LANGUAGE)+': '+KEEPER.battle.result.battleTime ,ASSETS.textStyles['common'],1,false);
        //timeText.anchor.setTo(0.5,0.5);
        /*
        ui.addButton(1,true,ui.width -48,48,32,32,'button_close',function(){
            ui.delete();
        },'onclick','onover',BUTTONVALUE);
        */
        ui.addButtonWithText(1,true,ui.width*0.5,ui.height*0.85,190,40,'button_empty',function(){
            onClose();
            //that.GUI.deleteUI(ui);
            
            that.closeBattle();
            
        },'onclick','onover',BUTTONVALUE,ASSETS.getText('text69',LANGUAGE),ASSETS.textStyles['button'],1);

        return firstUi;
    }
    closeBattle(){
        let that = this;
        //////НУЖНО УБРАТЬ ВСЕ АНИМАЦИИ
        for(let i in this.ourCards){
            this.ourCards[i].clearAllAnimations();
        }
        for(let i in this.ourArtifacts){
            this.ourArtifacts[i].clearAllAnimations();
        }
        for(let i in this.enemyCards){
            this.enemyCards[i].clearAllAnimations();
        }
        for(let i in this.enemyArtifacts){
            this.enemyArtifacts[i].clearAllAnimations();
        }
        
        //////////////////////////////
        
        if(KEEPER.battle.result.win){
            that.moveArtifactsOnBattleEnd('win')
        }else if(KEEPER.battle.result.winner == 'draw'){
            that.moveArtifactsOnBattleEnd('draw')
        }else{
            that.moveArtifactsOnBattleEnd('loose')
        }
            
        setTimeout(function(){
                ////Затухающий черный экран
            let newUi = that.mainUI.addUI(9,true,0,0,that.mainUI.width,that.mainUI.height,2);
            let bg = newUi.addBackgroundRect(1,true,false,0x000000,0x8B4513,1,0,1,true);
            let tween = game.add.tween(bg).to( {alpha: 1}, 1000, Phaser.Easing.Linear.None, true);
            tween.onComplete.add(function(){
                KEEPER.clearBattleData();
                game.state.start('LobbyState');
            }, that);
                    ////
        },2000);
    }
    moveArtifactsOnBattleEnd(resoult){
        let that = this;
        setTimeout(function(){
            ///Перебераем наши арты
            let ourCount = 0;
            let enemyCount = 0;
            for(let i = 0 ; i < that.ourArtifacts.length ; i++){
                let x,y;
                let isLoose = false;
                for(let j = 0; j < KEEPER.battle.result.loseArtifacts.length ; j++){
                    if(KEEPER.battle.result.loseArtifacts[j] === that.ourArtifacts[i].typeId){
                        isLoose = true;
                    }
                }
                if(isLoose){
                    if(resoult == 'draw'){
                        x = that.mainUI.width/2;
                        y = that.mainUI.height/2;
                    }else{
                        x = 64;
                        y = 64 + (enemyCount*3);  
                        enemyCount++;
                    }   
                }else{
                    x = 64;
                    y = that.mainUI.height - ( 64) - (ourCount*3);
                    ourCount++;
                }
                that.ourArtifacts[i].move(x,y,1000,function(){

                });
                that.ourArtifacts[i].sprite.input.enabled = false;
            }
            ///Перебераем вражеские арты
            for(let i = 0 ; i < that.enemyArtifacts.length ; i++){
                let x,y;
                let isLoose = false;
                for(let j = 0; j < KEEPER.battle.result.winArtifacts.length ; j++){
                    if(KEEPER.battle.result.winArtifacts[j] === that.enemyArtifacts[i].typeId){
                        isLoose = true;
                    }
                }
                if(isLoose){
                    if(resoult == 'draw'){
                        x = that.mainUI.width/2;
                        y = that.mainUI.height/2;
                    }else{
                        x = 64;
                        y = that.mainUI.height - ( 64) - (ourCount*3); 
                        ourCount++;
                    }   
                }else{
                    x = 64; 
                    y = 64 + (enemyCount*3); 
                    enemyCount++;
                }
                that.enemyArtifacts[i].move(x,y,1000,function(){

                });
                that.enemyArtifacts[i].sprite.input.enabled = false;
            }
        },500)
    }
    startCheckEndBattle(mainUI){
        let that = this;
        ////Если бой закончился
        //let endBattleWindow = null;
        let stopChek = false;
        mainUI.addUpdate(function(){
            if(!stopChek){
                if(KEEPER.battle.info.status == 'end'){
                    stopChek = true;
                    that.isEnd = true;
                }
            }
            
        });
    }
    addTurnTimer(mainUI){
        let that = this;
        //let ui = mainUI.addUI(1,true,mainUI.width*0.5 - 400/2,5,400,15,10);
        let ui = mainUI.addUI(1,true,mainUI.width - 20,mainUI.height*0.5 - 400/2,15,400,10);
        //let turnUI = mainUI.addUI(1,true,mainUI.width*0.5 - (150/2),20,150,50,10);
        let turnUI = mainUI.addUI(1,true,mainUI.width - 20 - 50,mainUI.height*0.5 - 150/2,50,150,10);
        //ui.addBackground(0,'ui_1',1,false);
        //turnUI.addBackground(0,'ui_1',1,false); 
         
        
        ui.addBackgroundRect(0,true,true,0x919191,0x8B4513,1,0.8,1,true);
        let turnImage = turnUI.addImage(1,true,turnUI.width*0.5,turnUI.height*0.5,50,50,'counter_1',1,false);
        let enemyCounterImage = turnUI.addImage(1,true,turnUI.width*0.5,turnUI.height*0.2,50,50,'counter_3',1,false);
        let ourCounterImage =  turnUI.addImage(1,true,turnUI.width*0.5,turnUI.height*0.8,50,50,'counter_2',1,false);
        //let turnNumberText = turnUI.addText(2,true,turnUI.width*0.5,turnUI.height*0.5,KEEPER.battle.info.turnNumber,ASSETS.textStyles['turnCounter'],1,true);
        let turnNumberText =  turnUI.addBitMapText(2,true,turnUI.width*0.5,turnUI.height*0.5,KEEPER.battle.info.turnNumber,'font_1',40,1,true);
        turnNumberText.tint = 0xFF4500;
        //turnNumberText.anchor.setTo(0.5,0.5);
        turnUI.addTitle(200,'left','bot',ASSETS.textStyles['title'],turnNumberText,function(){
            return ASSETS.getText('text47',LANGUAGE);
        });
        
        //let enemyCount = turnUI.addText(2,true,turnUI.width*0.5,turnUI.height*0.2,that.enemyWinsCount,ASSETS.textStyles['enemyWinsCount'],1,true);
        let enemyCount =  turnUI.addBitMapText(2,true,turnUI.width*0.5,turnUI.height*0.2,that.enemyWinsCount,'font_1',20,1,true);
        enemyCount.tint = 0xFF4500;
        //enemyCount.anchor.setTo(0.5,0.5);
        turnUI.addTitle(200,'left','bot',ASSETS.textStyles['title'],enemyCount,function(){
            return ASSETS.getText('text48',LANGUAGE);
        });
        
        //let ourCount = turnUI.addText(2,true,turnUI.width*0.5,turnUI.height*0.8,that.ourWinsCount,ASSETS.textStyles['ourWinsCount'],1,true);
        let ourCount =  turnUI.addBitMapText(2,true,turnUI.width*0.5,turnUI.height*0.8,that.ourWinsCount,'font_1',20,1,true);
        ourCount.tint = 0x90EE90;
        //ourCount.anchor.setTo(0.5,0.5);
        turnUI.addTitle(200,'left','bot',ASSETS.textStyles['title'],ourCount,function(){
            return ASSETS.getText('text49',LANGUAGE);
        });
        
       
        
        ///Тайм бар
        
        
        ui.addUpdatedRect(3,true,0,0,ui.width,ui.height,true,false,0xFF4500,0x000000,2,1,1,false,function(){
            return {x:0,y:0,width:ui.width,height:ui.height};
        });
        
        ui.addUpdatedRect(4,true,0,0,ui.width,ui.height,true,false,0xADFF2F,0x000000,2,1,1,false,function(){
            
            if(KEEPER.timers.battle.lastTurnTime){
                let current;
                if(KEEPER.timers.battle.leftPercentTurnTime < 0){
                    current = 0;
                }else{
                    current = KEEPER.timers.battle.leftPercentTurnTime;
                }
                //return {x:0,y:(ui.height - (current/100*ui.height))/2,width:ui.width,height:current/100*ui.height};
                return {x:0,y:(ui.height - (current/100*ui.height))/2,width:ui.width,height:current/100*ui.height};
            }else{
                return {x:0,y:0,width:ui.width,height:ui.height};
            }
            
        });
        ui.addImage(5,true,0+ui.width/2,0+ui.height/2,ui.width,ui.height,'timer_ui',1,false);
        ui.addUpdate(function(){
            if(KEEPER.battle.info.turnNumber !== 'LAST')
                turnNumberText.setText(KEEPER.battle.info.turnNumber);
            else
                turnNumberText.setText('');
            enemyCount.setText(that.enemyWinsCount);
            ourCount.setText(that.ourWinsCount);
        });
    }
    getFromArraybyId(id,array){
        for(let i in array){
            if(id == array[i].id)
                return array[i];
        }
        return false;
        
    }
    getOurCardById(id){
        for(let i in this.ourCards){
            if(this.ourCards[i]){
                if(this.ourCards[i].id == id){
                    return this.ourCards[i];
                }
            }
            
        }
    }
    getOurArtifactById(id){
        for(let i in this.ourArtifacts){
            if(this.ourArtifacts[i]){
                if(this.ourArtifacts[i].id == id){
                    return this.ourArtifacts[i];
                }
            }
            
        }
    }
    getOurCardByPosition(position){
        for(let i in this.ourCards){
            if(this.ourCards[i]){
                if(this.ourCards[i].position == position){
                    return this.ourCards[i];
                }
            }
            
        }
    }
    getEnemyCardByPosition(position){
         //console.log(position)
        for(let i in this.enemyCards){
            if(this.enemyCards[i]){
                if(this.enemyCards[i].position == position){
                    return this.enemyCards[i];
                }
            }
        }
    }
    addPlayerInfo(mainUI){
        let that = this;
        let enemyUI = mainUI.addUI(3,true,0,0,150,150,10);
        let levelCalor = 0x9932CC;
        
        if(KEEPER.enemy.isPlayer){
            let enemyStricUI = enemyUI.addUI(1,true,40,enemyUI.height+20,70,40,10);
            //enemyStricUI.addBackground(0,'ui_1',1,false); 
            let enemyStric = enemyStricUI.addImage(1,true,enemyStricUI.width*0.3,enemyStricUI.height*0.5,32,32,'skull',1,true);
            enemyStric.frame = 0;
            let enemyStricText = enemyStricUI.addBitMapText(1,true,enemyStricUI.width*0.7,enemyStricUI.height*0.5,''+KEEPER.enemy.stric+'','font_1',25,1,false);
            enemyStricText.tint = 0xFFFFFF;
            //stricText.anchor.setTo(0,0.5);
            enemyStricUI.addTitle(200,'right','bot',ASSETS.textStyles['title'],enemyStric,function(){
                return ASSETS.getText('text138',LANGUAGE);
            });
            console.log(KEEPER.enemy.level)
             let enemyLevel = enemyUI.addBitMapText(2,true,enemyUI.width-30,enemyUI.height - 30,''+KEEPER.enemy.level+'','font_1',35,1,false);
            
            enemyLevel.tint = levelCalor;
            console.log(enemyLevel)
        }
        
        //enemyUI.addBackground(0,'ui_1',1,false); 
        //enemyUI.addImage(1,true,enemyUI.width/2,enemyUI.height/2,enemyUI.width,enemyUI.height,'avatar_default',1,false);
        //enemyUI.addImage(1,true,enemyUI.width/2,enemyUI.height/2,enemyUI.width,enemyUI.height,'avatar_border',1,false);
        enemyUI.addImageWithMaskAndBorder(1,true,enemyUI.width/2,enemyUI.height/2,enemyUI.width,enemyUI.height,'avatar_'+KEEPER.enemy.avatar.image,'border_'+KEEPER.enemy.avatar.border+'_mask','border_'+KEEPER.enemy.avatar.border,1,false); 
        let enemyName = enemyUI.addBitMapText(1,true,enemyUI.width/2,enemyUI.height*1.05,KEEPER.enemy.name,'font_1',20,1,false);
        //let countImage1 = enemyUI.addImage(1,true,enemyUI.width-30,enemyUI.height - 30,32,32,'circle',1,false);
       enemyName.tint = 0xFFD700;
            
        
        
        
        
        //let enemyName = enemyUI.addText(1,true,enemyUI.width/2,enemyUI.height*0.9,KEEPER.enemy.name,ASSETS.textStyles['playerName'],1,true);
        //enemyName.anchor.setTo(0.5,0.5);
        let ourUI = mainUI.addUI(3,true,0,mainUI.height - ( 150),150,150,10);
        //ourUI.addBackground(0,'ui_1',1,false); 
        //ourUI.addImage(1,true,ourUI.width/2,ourUI.height/2,ourUI.width,ourUI.height,'avatar_default',1,false);
        //ourUI.addImage(1,true,ourUI.width/2,ourUI.height/2,ourUI.width,ourUI.height,'avatar_border',1,false);
        //ourUI.addImageWithMaskAndBorder(1,true,ui.width*0.2,ui.height*0.4,128,128,imageKey,maskKey,borderKey,1,false);
        ourUI.addImageWithMaskAndBorder(1,true,ourUI.width/2,ourUI.height/2,ourUI.width,ourUI.height,'avatar_'+KEEPER.user.avatar.image,'border_'+KEEPER.user.avatar.border+'_mask','border_'+KEEPER.user.avatar.border,1,false);  
        
        let ourName = ourUI.addBitMapText(1,true,ourUI.width/2,-ourUI.height*0.05,KEEPER.user.name,'font_1',20,1,false);
        //let countImage2 = ourUI.addImage(1,true,ourUI.width-30,30,32,32,'star',1,false);
        let ourLevel = ourUI.addBitMapText(1,true,ourUI.width-30,30,KEEPER.user.level,'font_1',35,1,false);
        ourName.tint = 0xFFD700;
        ourLevel.tint = levelCalor;
        
        let ourStricUI = ourUI.addUI(1,true,40,-60,70,40,10);
        //ourStricUI.addBackground(0,'ui_1',1,false); 
        let ourStric = ourStricUI.addImage(1,true,ourStricUI.width*0.3,ourStricUI.height*0.5,32,32,'skull',1,true);
        ourStric.frame = 0;
        let ourStricText = ourStricUI.addBitMapText(1,true,ourStricUI.width*0.7,ourStricUI.height*0.5,''+KEEPER.user.skills.botWinLevel+'','font_1',25,1,false);
        ourStricText.tint = 0xFFFFFF;
        //stricText.anchor.setTo(0,0.5);
        ourStricUI.addTitle(200,'right','bot',ASSETS.textStyles['title'],ourStric,function(){
            return ASSETS.getText('text138',LANGUAGE);
        });
        //let ourName = ourUI.addText(1,true,ourUI.width/2,ourUI.height*0.9,KEEPER.user.name,ASSETS.textStyles['playerName'],1,true);
        //ourName.anchor.setTo(0.5,0.5);
         mainUI.addUpdate(function(){
             ourStricText.setText(''+KEEPER.user.skills.botWinLevel+'');
             enemyName.setText(KEEPER.enemy.name);
             ourName.setText(KEEPER.user.name);
             
         });
    }
    isAllCreaturesHasArtifacts(){
        let count = 0;
        for(let i in this.ourCards){
            if(this.ourCards[i].hasArtifact())
                count++;
        }
        for(let i in this.enemyCards){
            if(this.enemyCards[i].hasArtifact())
                count++;
        }
        ///Если поставлено 10 артов
        if(count === 10){
            return true;
        }else{
            return false;
        }
    }
    isAllOurCreaturesHasArtifacts(){
        let count = 0;
        for(let i in this.ourCards){
            if(this.ourCards[i].hasArtifact())
                count++;
        }
        ///Если поставлено 10 артов
        if(count === 5){
            return true;
        }else{
            return false;
        }
    }
    isAllEnemyCreaturesHasArtifacts(){
        let count = 0;
        for(let i in this.enemyCards){
            if(this.enemyCards[i].hasArtifact())
                count++;
        }
        ///Если поставлено 10 артов
        if(count === 5){
            return true;
        }else{
            return false;
        }
    }
    getTypesCount(array,type){
        let cardTypes = [];
        for(let i in array){
            switch(type){
                case 'race':
                    if(array[i].raceId){
                        if(!this.isInArray(array[i].raceId,cardTypes)){
                            cardTypes.push(array[i].raceId);
                        }
                    } 
                    break;
                 case 'class': 
                    if(array[i].classId){
                        if(!this.isInArray(array[i].classId,cardTypes)){
                            cardTypes.push(array[i].classId);
                        }
                    } 
                    break;
            }
            
        }
        return cardTypes.length;
    }
    isInArray(obj,array){
        for(let i in array){
            if(array[i] == obj)
                return true;
        }
        return false;
    }
    showTuntTextIfNeed(){
        let needShowHint = false;
        switch(KEEPER.battle.info.battleType){
            case 'tutorial': needShowHint = true;   
        }
        if(needShowHint)
            this.showHint();
    }
    showHint(){
        var that = this;
        
        //let ui = mainUI.addUI(5,true,mainUI.width/2 - 300,mainUI.height/2 - 150,600,300,10);
        let ui = that.GUI.addUI(this.game.width/2 - 300,this.game.height/2 - 150,600,300,null,null,10);
        ui.addFullWindowRect(0,0,0,this.game.width,this.game.height,true,0x000000,0,function(){
            ui.delete();
        });
        let text = ui.addUIWithBitmapTextAndImage(1,true,ui.width*0.5,ui.height*0.5,950,'center',ASSETS.getText(this.getHintString(),LANGUAGE),ASSETS.wordStyles,ASSETS.textStyles['bigWhite'],40,0,false)
        //let text = ui.addWidgetWithTextAndImage(1,ui.width*0.5,y,width,align,string,wordTypes,style,stringSize,alpha,inputEnable)
        //let text = ui.addText(1,true,ui.width*0.5,ui.height*0.5,ASSETS.getText(this.getHintString(number),LANGUAGE),ASSETS.textStyles['commonString'],0,false);
        //text.anchor.setTo(0.5,0.5);
        //text.anchor.setTo(0.5,0.5);
        /*
        let buttonClose = ui.addButton(1,true,ui.width -25,25,32,32,'button_close',function(){
            onClose();
        },'onclick','onover',BUTTONVALUE);
        */
        //buttonClose.alpha = 0;
        //ui.addBackground(0,'ui_600_300',0,false);
        ui.addTween(['texts','images'],{ alpha: 1 },2000);
        ui.addTween(['graphics'],{ alpha: 0.8 },500);
    }
    showHelpBet(mainUI){
        let card = this.getOurCardById(KEEPER.battle.data.helpCreaturesId);
        let artifact = this.getOurArtifactById(KEEPER.battle.data.helpArtifactsId);
        let line = mainUI.addLine(99,true,card.x,card.y,artifact.x,artifact.y,0xFFD700,5,1,false);
        setTimeout(function(){
            line.destroy();
        },1000);
        
    }
    getHintString(){
        let str = '';
        switch(KEEPER.battle.info.battleType){
            case 'tutorial': str = 'tutorialText_'+KEEPER.battle.info.args[0]+'_'+this.currentTurn ; break;
                
        }
        return str;
    }
}